![](https://raw.githubusercontent.com/dpnishant/appmon/master/resources/logo.png)
Welcome to AppMon!
==================
As seen at [![](https://www.toolswatch.org/badges/arsenal/2016.svg)](https://www.blackhat.com/us-16/arsenal.html#appmon) US & [![](https://www.toolswatch.org/badges/arsenal/2016.svg)](https://www.blackhat.com/eu-16/arsenal.html#appmon-runtime-security-testing-and-profiling-framework-for-native-apps) EU

[![Backers on Open Collective](https://opencollective.com/appmon/backers/badge.svg)](#backers)
 [![Sponsors on Open Collective](https://opencollective.com/appmon/sponsors/badge.svg)](#sponsors) 

AppMon is an automated framework for monitoring and tampering system API calls of native macOS, iOS and android apps. It is based on [**Frida**](http://www.frida.re).

This project was only possible because of **Ole André Vadla Ravnås** and I dedicate it to him. Follow him on [**GitHub**](https://github.com/oleavr), [**Twitter**](https://twitter.com/oleavr)

It consists of the following components:

* AppMon Sniffer - Intercept API calls to figure out interesting operations performed by an App
* Appmon Intruder - Manipulate API calls data to create change app's original behavior
* AppMon Android Tracer - Automatically traces Java classes, methods, its arguments and their data-types in Android APKs
* AppMon IPA Installer - Creates and installs "inspectable" IPAs on non-jailbroken iOS devices
* AppMon APK Builder - Creates APKs "inspectable" on non-rooted Android devices

New/Experimental Features
=====================
[Details](https://github.com/dpnishant/appmon/wiki/Experimental-Features)


Documentation
=============
Follow the documentation below to learn more.
[Click Here](https://dpnishant.github.io/appmon/)


Credits
=============

|JetBrains|
|:-:|
|![JetBrains](https://github.com/dpnishant/appmon/raw/master/resources/external/jetbrains.png)|
|Many thanks to [JetBrains s.r.o.](https://www.jetbrains.com) for providing a free license of [All Products Pack](https://www.jetbrains.com/store/?fromMenu#edition=personal) to kindly support the development of appmon.|

## Contributors

This project exists thanks to all the people who contribute. 
<a href="graphs/contributors"><img src="https://opencollective.com/appmon/contributors.svg?width=890&button=false" /></a>


## Backers

Thank you to all our backers! 🙏 [[Become a backer](https://opencollective.com/appmon#backer)]

<a href="https://opencollective.com/appmon#backers" target="_blank"><img src="https://opencollective.com/appmon/backers.svg?width=890"></a>


## Sponsors

Support this project by becoming a sponsor. Your logo will show up here with a link to your website. [[Become a sponsor](https://opencollective.com/appmon#sponsor)]

<a href="https://opencollective.com/appmon/sponsor/0/website" target="_blank"><img src="https://opencollective.com/appmon/sponsor/0/avatar.svg"></a>
<a href="https://opencollective.com/appmon/sponsor/1/website" target="_blank"><img src="https://opencollective.com/appmon/sponsor/1/avatar.svg"></a>
<a href="https://opencollective.com/appmon/sponsor/2/website" target="_blank"><img src="https://opencollective.com/appmon/sponsor/2/avatar.svg"></a>
<a href="https://opencollective.com/appmon/sponsor/3/website" target="_blank"><img src="https://opencollective.com/appmon/sponsor/3/avatar.svg"></a>
<a href="https://opencollective.com/appmon/sponsor/4/website" target="_blank"><img src="https://opencollective.com/appmon/sponsor/4/avatar.svg"></a>
<a href="https://opencollective.com/appmon/sponsor/5/website" target="_blank"><img src="https://opencollective.com/appmon/sponsor/5/avatar.svg"></a>
<a href="https://opencollective.com/appmon/sponsor/6/website" target="_blank"><img src="https://opencollective.com/appmon/sponsor/6/avatar.svg"></a>
<a href="https://opencollective.com/appmon/sponsor/7/website" target="_blank"><img src="https://opencollective.com/appmon/sponsor/7/avatar.svg"></a>
<a href="https://opencollective.com/appmon/sponsor/8/website" target="_blank"><img src="https://opencollective.com/appmon/sponsor/8/avatar.svg"></a>
<a href="https://opencollective.com/appmon/sponsor/9/website" target="_blank"><img src="https://opencollective.com/appmon/sponsor/9/avatar.svg"></a>


